#include <freetype.h>

struct name_properties_ {
    TT_UShort platformID;
    TT_UShort encodingID;
    TT_UShort languageID;
    TT_UShort nameID;
};
typedef struct name_properties_ name_properties;
struct type1_properties_ {
    char fullname[128];
    char fontname[128];
    char postname[128];
    char vendor[128];
    char weight[128];
    int  pitch, italic, uniqid;
};
typedef struct type1_properties_ type1_properties;
unsigned int sjis2euc(unsigned int);
unsigned int utf2euc(unsigned int);
int han2zen(unsigned int*, unsigned char*);
void get_name_properties(TT_Face, int, name_properties*);
char* get_platform(name_properties);
char* get_encoding(name_properties);
char* get_language(name_properties);
char* get_desc(name_properties);
char* get_vendor(TT_OS2);
void get_namestring(TT_Face, TT_UShort, int, char*);
void get_type1_line(FILE*, char*);
int  get_type1_string(char*, type1_properties*);
