#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
void create_fileselection1_ok(GtkWidget*);
void on_quit_activate();
void on_install_activate();
void on_config_activate();
char** ttfdir(char*, GtkWidget*, int, char*);
void ttf_files(char*, char*, char*, char*);
void on_clist_select_row(GtkWidget*, int, int, GdkEventButton*, int);
void on_clist_unselect_row(GtkWidget*, int, int, GdkEventButton*, int);
void on_addbtn_clicked();
void on_delbtn_clicked();
void on_set_clicked(int);
void on_unset_clicked(int);
GtkWidget* create_window1();
GtkWidget *combos[2], *faceselect[3], *errmsg;
void set_combo();
void save_default();
int get_face_setting();
void change_face(GtkWidget*, int);

#define MINCHO  0
#define GOTH 	1
typedef struct listset_ {
  char **list;
  GtkWidget *clist;
  char path[1024];
  char atmpath[1024];
} listset;
listset fontlist[2];

int main (int argc, char *argv[]) {
  GtkWidget *window1;
  FILE *fp;
  char name[2][256];
  
  fontlist[0].list = fontlist[1].list = NULL;
  strcpy(fontlist[0].path, "/usr/X11R6/lib/X11/fonts/TrueType");
  strcpy(fontlist[0].atmpath, "/usr/X11R6/lib/X11/fonts/Type1");
  if((fp = fopen("/etc/startup.ttfdef", "r")) != NULL) {
    while(fgets(name[0], 256, fp) != NULL) {
      name[0][strlen(name[0]) - 1] = 0;
      if(strncmp(name[0], "path ", 5) == 0) {
        strcpy(fontlist[0].path, name[0] + 5);
      } else if(strncmp(name[0], "atmpath ", 8) == 0) {
        strcpy(fontlist[0].atmpath, name[0] + 8);
      }
    }
    fclose(fp);
  }
  if((fp = fopen(fontlist[0].path, "r")) == NULL)
    mkdir(fontlist[0].path);
  else
    fclose(fp);
  if((fp = fopen(fontlist[0].atmpath, "r")) == NULL)
    mkdir(fontlist[0].atmpath);
  else
    fclose(fp);
  name[0][0] = 0;
  if((fp = fopen("/etc/ttftool.default", "r")) != NULL) {
    fgets(name[0], 256, fp);
    name[0][strlen(name[0]) - 1] = 0;
    fgets(name[1], 256, fp);
    name[1][strlen(name[1]) - 1] = 0;
    fclose(fp);
  }
  gtk_set_locale ();
  gtk_init (&argc, &argv);
  window1 = create_window1 ();
  gtk_widget_show (window1);
  if(fontlist[0].list != NULL) free(fontlist[0].list);
  fontlist[0].list = ttfdir(fontlist[0].path, fontlist[0].clist, 0, fontlist[0].atmpath);
  set_combo();
  if(name[0][0] != 0) {
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combos[MINCHO])->entry), name[0]);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combos[GOTH])->entry), name[1]);
  }
  
  gtk_main ();
  return 0;
}

GtkWidget* create_window1 ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file;
  GtkWidget *file_menu;
  GtkWidget *install;
  GtkWidget *config;
  GtkWidget *quit;
  GtkWidget *title;
  GtkWidget *hbox1;
  GtkWidget *vbox3;
  GtkWidget *master;
  GtkWidget *scrolledwindow2;
  GtkWidget *maslabel;
  GtkWidget *vbuttonbox1;
  GtkWidget *hbuttonbox1;
  GtkWidget *set1;
  GtkWidget *vbuttonbox2;
  GtkWidget *hbuttonbox2;
  GtkWidget *set2;
  GtkWidget *unset1;
  GtkWidget *unset2;
  GtkWidget *addbtn;
  GtkWidget *delbtn;
  GtkWidget *vbox4;
  GtkWidget *add;
  GtkWidget *scrolledwindow3;
  GtkWidget *addlabel;
  GtkWidget *vbox2;
  GtkWidget *hbox2;
  GtkWidget *minlabel;
  GtkWidget *hbox3;
  GtkWidget *gothlabel;
  GtkWidget *xset;
  GSList *face_group = NULL;
  GtkWidget *checkbutton2;
  GtkWidget *checkbutton3;
  GtkWidget *checkbutton4;
  GtkWidget *checkbutton5;
  GtkWidget *checkbutton6;
  GtkWidget *checkbutton7;
  GtkWidget *checkbutton8;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "window1");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menubar1", menubar1);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  file = gtk_menu_item_new_with_label ("ե");
  gtk_object_set_data (GTK_OBJECT (window1), "file", file);
  gtk_widget_show (file);
  gtk_container_add (GTK_CONTAINER (menubar1), file);

  file_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "file_menu", file_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);

  install = gtk_menu_item_new_with_label ("󥹥ȡ");
  gtk_object_set_data (GTK_OBJECT (window1), "install", install);
  gtk_widget_show (install);
  gtk_container_add (GTK_CONTAINER (file_menu), install);

  config = gtk_menu_item_new_with_label ("եν񤭽Ф");
  gtk_object_set_data (GTK_OBJECT (window1), "config", config);
  gtk_widget_show (config);
  gtk_container_add (GTK_CONTAINER (file_menu), config);

  quit = gtk_menu_item_new_with_label ("λ");
  gtk_object_set_data (GTK_OBJECT (window1), "quit", quit);
  gtk_widget_show (quit);
  gtk_container_add (GTK_CONTAINER (file_menu), quit);

  title = gtk_label_new ("ե ȥѥͥ Ver 4.3");
  gtk_object_set_data (GTK_OBJECT (window1), "title", title);
  gtk_widget_show (title);
  gtk_box_pack_start (GTK_BOX (vbox1), title, FALSE, FALSE, 11);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox3, TRUE, TRUE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2);
  gtk_widget_set_usize (scrolledwindow2, 200, 400);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  fontlist[0].clist = gtk_clist_new (1);
  gtk_object_set_data (GTK_OBJECT (window1), "fontlist[0].clist", fontlist[0].clist);
  gtk_widget_show (fontlist[0].clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), fontlist[0].clist);
  gtk_clist_set_selection_mode (GTK_CLIST (fontlist[0].clist), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (fontlist[0].clist));

  maslabel = gtk_label_new ("ϿѤΥե");
  gtk_object_set_data (GTK_OBJECT (window1), "maslabel", maslabel);
  gtk_widget_show (maslabel);
  gtk_clist_set_column_widget (GTK_CLIST (fontlist[0].clist), 0, maslabel);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "hbuttonbox1", hbuttonbox1);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox3), hbuttonbox1, FALSE, FALSE, 0);

  set1 = gtk_button_new_with_label ("");
  gtk_object_set_data (GTK_OBJECT (window1), "set1", set1);
  gtk_widget_show (set1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), set1);
  GTK_WIDGET_SET_FLAGS (set1, GTK_CAN_DEFAULT);

  unset1 = gtk_button_new_with_label ("");
  gtk_object_set_data (GTK_OBJECT (window1), "unset1", unset1);
  gtk_widget_show (unset1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), unset1);
  GTK_WIDGET_SET_FLAGS (unset1, GTK_CAN_DEFAULT);

  vbuttonbox1 = gtk_vbutton_box_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "vbuttonbox1", vbuttonbox1);
  gtk_widget_show (vbuttonbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbuttonbox1, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox1), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (vbuttonbox1), 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (vbuttonbox1), 0, 0);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (vbuttonbox1), 0, 0);

  addbtn = gtk_button_new_with_label ("Ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "addbtn", addbtn);
  gtk_widget_show (addbtn);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), addbtn);
  GTK_WIDGET_SET_FLAGS (addbtn, GTK_CAN_DEFAULT);

  delbtn = gtk_button_new_with_label ("");
  gtk_object_set_data (GTK_OBJECT (window1), "delbtn", delbtn);
  gtk_widget_show (delbtn);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), delbtn);
  GTK_WIDGET_SET_FLAGS (delbtn, GTK_CAN_DEFAULT);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "vbox4", vbox4);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox4, TRUE, TRUE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (window1), "scrolledwindow3", scrolledwindow3);
  gtk_widget_set_usize (scrolledwindow3, 200, 400);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  fontlist[1].clist = gtk_clist_new (1);
  gtk_object_set_data (GTK_OBJECT (window1), "fontlist[1].clist", fontlist[1].clist);
  gtk_widget_show (fontlist[1].clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), fontlist[1].clist);
  gtk_clist_set_selection_mode (GTK_CLIST (fontlist[1].clist), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (fontlist[1].clist));

  addlabel = gtk_label_new ("ɲоݤΥե");
  gtk_object_set_data (GTK_OBJECT (window1), "addlabel", addlabel);
  gtk_widget_show (addlabel);
  gtk_clist_set_column_widget (GTK_CLIST (fontlist[1].clist), 0, addlabel);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "hbuttonbox2", hbuttonbox2);
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox4), hbuttonbox2, FALSE, FALSE, 0);

  set2 = gtk_button_new_with_label ("");
  gtk_object_set_data (GTK_OBJECT (window1), "set2", set2);
  gtk_widget_show (set2);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), set2);
  GTK_WIDGET_SET_FLAGS (set2, GTK_CAN_DEFAULT);

  unset2 = gtk_button_new_with_label ("");
  gtk_object_set_data (GTK_OBJECT (window1), "unset2", unset2);
  gtk_widget_show (unset2);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), unset2);
  GTK_WIDGET_SET_FLAGS (unset2, GTK_CAN_DEFAULT);

  vbox2 = gtk_vbox_new (FALSE, 4);
  gtk_object_set_data (GTK_OBJECT (window1), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 8);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, FALSE, 0);

  minlabel = gtk_label_new ("ī");
  gtk_object_set_data (GTK_OBJECT (window1), "minlabel", minlabel);
  gtk_widget_show (minlabel);
  gtk_box_pack_start (GTK_BOX (hbox2), minlabel, FALSE, FALSE, 0);
  gtk_widget_set_usize (minlabel, 60, 16);

  combos[MINCHO] = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "combos[MINCHO]", combos[MINCHO]);
  gtk_widget_set_usize (combos[MINCHO], 200, -1);
  gtk_widget_show (combos[MINCHO]);
  gtk_box_pack_start (GTK_BOX (hbox2), combos[MINCHO], TRUE, TRUE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, FALSE, 0);

  gothlabel = gtk_label_new ("å");
  gtk_object_set_data (GTK_OBJECT (window1), "gothlabel", gothlabel);
  gtk_widget_show (gothlabel);
  gtk_box_pack_start (GTK_BOX (hbox3), gothlabel, FALSE, FALSE, 0);
  gtk_widget_set_usize (gothlabel, 60, 16);

  combos[GOTH] = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "combos[GOTH]", combos[GOTH]);
  gtk_widget_set_usize (combos[GOTH], 200, -1);
  gtk_widget_show (combos[GOTH]);
  gtk_box_pack_start (GTK_BOX (hbox3), combos[GOTH], TRUE, TRUE, 0);

  faceselect[0] = gtk_radio_button_new_with_label (face_group, "ĤΥեΤ");
  face_group = gtk_radio_button_group (GTK_RADIO_BUTTON (faceselect[0]));
  gtk_object_set_data (GTK_OBJECT (window1), "faceselect[0]", faceselect[0]);
  gtk_widget_show (faceselect[0]);
  gtk_box_pack_start (GTK_BOX (vbox2), faceselect[0], FALSE, FALSE, 0);

  faceselect[1] = gtk_radio_button_new_with_label (face_group, "ĤΥե");
  face_group = gtk_radio_button_group (GTK_RADIO_BUTTON (faceselect[1]));
  gtk_object_set_data (GTK_OBJECT (window1), "faceselect[1]", faceselect[1]);
  gtk_widget_show (faceselect[1]);
  gtk_box_pack_start (GTK_BOX (vbox2), faceselect[1], FALSE, FALSE, 0);

  faceselect[2] = gtk_radio_button_new_with_label (face_group, "ƤΥե");
  face_group = gtk_radio_button_group (GTK_RADIO_BUTTON (faceselect[2]));
  gtk_object_set_data (GTK_OBJECT (window1), "faceselect[2]", faceselect[2]);
  gtk_widget_show (faceselect[2]);
  gtk_box_pack_start (GTK_BOX (vbox2), faceselect[2], FALSE, FALSE, 0);

  errmsg = gtk_label_new ("");
  gtk_object_set_data (GTK_OBJECT (window1), "errmsg", errmsg);
  gtk_widget_show (errmsg);
  gtk_box_pack_start (GTK_BOX (vbox2), errmsg, FALSE, FALSE, 0);

/*  xset = gtk_check_button_new_with_label ("Xɥ(fonts.dir)");
  gtk_object_set_data (GTK_OBJECT (window1), "xset", xset);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (xset), TRUE);
  gtk_widget_show (xset);
  gtk_box_pack_start (GTK_BOX (vbox2), xset, FALSE, FALSE, 0);

  checkbutton2 = gtk_check_button_new_with_label ("ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "checkbutton2", checkbutton2);
  gtk_widget_show (checkbutton2);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton2, FALSE, FALSE, 0);

  checkbutton3 = gtk_check_button_new_with_label ("ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "checkbutton3", checkbutton3);
  gtk_widget_show (checkbutton3);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton3, FALSE, FALSE, 0);

  checkbutton4 = gtk_check_button_new_with_label ("ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "checkbutton4", checkbutton4);
  gtk_widget_show (checkbutton4);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton4, FALSE, FALSE, 0);

  checkbutton5 = gtk_check_button_new_with_label ("ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "checkbutton5", checkbutton5);
  gtk_widget_show (checkbutton5);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton5, FALSE, FALSE, 0);

  checkbutton6 = gtk_check_button_new_with_label ("ͽ");
  gtk_object_set_data (GTK_OBJECT (window1), "checkbutton6", checkbutton6);
  gtk_widget_show (checkbutton6);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton6, FALSE, FALSE, 0);*/

  gtk_signal_connect (GTK_OBJECT (window1), "destroy",
		      GTK_SIGNAL_FUNC (on_quit_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (install), "activate",
                      GTK_SIGNAL_FUNC (on_install_activate), (gpointer)fontlist[1].clist);
  gtk_signal_connect (GTK_OBJECT (config), "activate",
                      GTK_SIGNAL_FUNC (on_config_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (quit), "activate",
                      GTK_SIGNAL_FUNC (on_quit_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (fontlist[0].clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist_select_row), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (fontlist[0].clist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_clist_unselect_row), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (fontlist[1].clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist_select_row), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (fontlist[1].clist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_clist_unselect_row), (gpointer)1);
  gtk_signal_connect_object(GTK_OBJECT(addbtn), "clicked",
                            (GtkSignalFunc)on_addbtn_clicked, NULL);
  gtk_signal_connect_object(GTK_OBJECT(delbtn), "clicked",
                            (GtkSignalFunc)on_delbtn_clicked, NULL);
  gtk_signal_connect_object(GTK_OBJECT(set1), "clicked",
                            (GtkSignalFunc)on_set_clicked, (gpointer)0);
  gtk_signal_connect_object(GTK_OBJECT(unset1), "clicked",
                            (GtkSignalFunc)on_unset_clicked, (gpointer)0);
  gtk_signal_connect_object(GTK_OBJECT(set2), "clicked",
                            (GtkSignalFunc)on_set_clicked, (gpointer)1);
  gtk_signal_connect_object(GTK_OBJECT(unset2), "clicked",
                            (GtkSignalFunc)on_unset_clicked, (gpointer)1);
  gtk_signal_connect (GTK_OBJECT(GTK_COMBO(combos[MINCHO])->entry), "changed",
                      GTK_SIGNAL_FUNC(save_default), NULL);
  gtk_signal_connect (GTK_OBJECT(GTK_COMBO(combos[GOTH])->entry), "changed",
                      GTK_SIGNAL_FUNC(save_default), NULL);
  gtk_signal_connect (GTK_OBJECT(faceselect[0]), "clicked",
                      GTK_SIGNAL_FUNC(change_face), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT(faceselect[1]), "clicked",
                      GTK_SIGNAL_FUNC(change_face), (gpointer)2);
  gtk_signal_connect (GTK_OBJECT(faceselect[2]), "clicked",
                      GTK_SIGNAL_FUNC(change_face), (gpointer)3);
  return window1;
}

GtkWidget* create_fileselection1() {
  GtkWidget *fileselection1;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  fileselection1 = gtk_file_selection_new ("install");
  gtk_object_set_data (GTK_OBJECT (fileselection1), "fileselection1", fileselection1);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection1), 10);
  GTK_WINDOW (fileselection1)->type = GTK_WINDOW_DIALOG;
  gtk_signal_connect(GTK_OBJECT(fileselection1), "destroy",
                     (GtkSignalFunc)gtk_grab_remove, NULL);

  ok_button1 = GTK_FILE_SELECTION (fileselection1)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection1), "ok_button1", ok_button1);
  gtk_signal_connect_object(GTK_OBJECT(ok_button1), "clicked",
                            (GtkSignalFunc)create_fileselection1_ok, (gpointer)fileselection1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (fileselection1)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection1), "cancel_button1", cancel_button1);
  gtk_signal_connect_object(GTK_OBJECT(cancel_button1), "clicked",
                            (GtkSignalFunc)gtk_widget_destroy, (gpointer)fileselection1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  return fileselection1;
}

void create_fileselection1_ok(GtkWidget *widget) {
  char *filename, *ptr;

  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(widget));
  ptr = strrchr(filename, '/');
  if(ptr != NULL) *ptr = 0;
  if(fontlist[1].list != NULL) free(fontlist[1].list);
  strcpy(fontlist[1].path, filename);
  fontlist[1].list = ttfdir(filename, fontlist[1].clist, 1, NULL);
  gtk_widget_destroy(widget);
}

void on_quit_activate(){
  if(fontlist[0].list != NULL) free(fontlist[0].list);
  if(fontlist[1].list != NULL) free(fontlist[1].list);
  gtk_main_quit();
}

void on_install_activate(){
  GtkWidget *fileselection1;

  fileselection1 = create_fileselection1();
  gtk_widget_show(fileselection1);
  gtk_grab_add(fileselection1);
}

void on_config_activate(){
  int i;
  char *text, minf[256], gothf[256], minn[256], gothn[256];

  strcpy(minn, gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combos[MINCHO])->entry)));
  strcpy(gothn, gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combos[GOTH])->entry)));
  strcpy(minf, fontlist[0].list[0]);
  strcpy(gothf, fontlist[0].list[0]);
  for(i = 0;fontlist[0].list[i] != NULL;i++) {
    gtk_clist_get_text(GTK_CLIST(fontlist[0].clist), i, 0, &text);
    if(strcmp(text, minn) == 0) strcpy(minf, fontlist[0].list[i]);
    if(strcmp(text, gothn) == 0) strcpy(gothf, fontlist[0].list[i]);
  }
  ttf_files(fontlist[0].path, fontlist[0].atmpath, minf, gothf);
}

void on_clist_select_row(GtkWidget *clist, int row, int column, GdkEventButton *event, int index) {
  int i;

  i = strlen(fontlist[index].list[row]);
  fontlist[index].list[row][i + 1] = '*';
}

void on_clist_unselect_row(GtkWidget *clist, int row, int column, GdkEventButton *event, int index) {
  int i;

  i = strlen(fontlist[index].list[row]);
  fontlist[index].list[row][i + 1] = 0;
}

void on_addbtn_clicked(){
  int i, n, a;
  char command[2048], path[512];

  for(i = 0;fontlist[1].list[i] != NULL;i++) {
    n = strlen(fontlist[1].list[i]);
    if(fontlist[1].list[i][n + 1] == '*') {
      for(a = 0;fontlist[1].list[i][a] != 0;a++) path[a] = tolower(fontlist[1].list[i][a]);
      path[a]= 0;
      if(fontlist[1].list[i][n + 2] == 't') {
        sprintf(command, "cp %s/%s %s/%s", fontlist[1].path, fontlist[1].list[i], fontlist[0].path, path);
        system(command);
        ttfinstall(fontlist[0].path, path, "/etc/install.ttfdef");
      } else if(fontlist[1].list[i][n + 2] == 'a') {
        sprintf(command, "cp %s/%s %s/%s", fontlist[1].path, fontlist[1].list[i], fontlist[0].atmpath, path);
        system(command);
        ttfinstall(fontlist[0].atmpath, path, "/etc/instatm.ttfdef");
      }
    }
  }
  if(fontlist[0].list != NULL) free(fontlist[0].list);
  fontlist[0].list = ttfdir(fontlist[0].path, fontlist[0].clist, 0, fontlist[0].atmpath);
  set_combo();
  on_unset_clicked(1);
}

void on_delbtn_clicked(){
  int i, n;
  char fullpath[2048];

  for(i = 0;fontlist[0].list[i] != NULL;i++) {
    n = strlen(fontlist[0].list[i]);
    if(fontlist[0].list[i][n + 1] == '*') {
      if(fontlist[0].list[i][n + 2] == 't') {
        sprintf(fullpath, "%s/%s", fontlist[0].path, fontlist[0].list[i]);
        unlink(fullpath);
      } else if(fontlist[0].list[i][n + 2] == 'a') {
        sprintf(fullpath, "%s/%s", fontlist[0].atmpath, fontlist[0].list[i]);
        unlink(fullpath);
      }
    }
  }
  if(fontlist[0].list != NULL) free(fontlist[0].list);
  fontlist[0].list = ttfdir(fontlist[0].path, fontlist[0].clist, 0, fontlist[0].atmpath);
  set_combo();
}

void on_set_clicked(int index){
  int i, n;

  gtk_clist_select_all(GTK_CLIST(fontlist[index].clist));
  for(i = 0;fontlist[index].list[i] != NULL;i++) {
    n = strlen(fontlist[index].list[i]);
    fontlist[index].list[i][n + 1] = '*';
  }
}

void on_unset_clicked(int index){
  int i, n;

  gtk_clist_unselect_all(GTK_CLIST(fontlist[index].clist));
  for(i = 0;fontlist[index].list[i] != NULL;i++) {
    n = strlen(fontlist[index].list[i]);
    fontlist[index].list[i][n + 1] = 0;
  }
}

void set_combo() {
  int i;
  char *text;
  GList *min_item, *goth_item, *other_item;

  min_item = goth_item = other_item = NULL;
  for(i = 0;fontlist[0].list[i] != NULL;i++) {
    gtk_clist_get_text(GTK_CLIST(fontlist[0].clist), i, 0, &text);
    other_item = g_list_append(other_item, text);
    if(strstr(text, "ī") != NULL) min_item = g_list_append(min_item, text);
    if(strstr(text, "ʽ") != NULL) min_item = g_list_append(min_item, text);
    if(strstr(text, "å") != NULL) goth_item = g_list_append(goth_item, text);
  }
  if(min_item == NULL)
    gtk_combo_set_popdown_strings(GTK_COMBO(combos[MINCHO]), other_item);
  else
    gtk_combo_set_popdown_strings(GTK_COMBO(combos[MINCHO]), min_item);
  if(goth_item == NULL)
    gtk_combo_set_popdown_strings(GTK_COMBO(combos[GOTH]), other_item);
  else
    gtk_combo_set_popdown_strings(GTK_COMBO(combos[GOTH]), goth_item);
  g_list_free(min_item);
  g_list_free(goth_item);
  g_list_free(other_item);
}

void save_default() {
  FILE *fp;
  
  fp = fopen("/etc/ttftool.default", "w");
  fprintf(fp, "%s\n", gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combos[MINCHO])->entry)));
  fprintf(fp, "%s\n", gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combos[GOTH])->entry)));
  fclose(fp);
}

void change_face(GtkWidget *w, int n) {
  if(fontlist[0].list != NULL) free(fontlist[0].list);
  fontlist[0].list = ttfdir(fontlist[0].path, fontlist[0].clist, 0, fontlist[0].atmpath);
}

int get_max_face() {
  int i, n;

  n = 0;
  for(i = 0;i < 3;i++)
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(faceselect[i]))) n = i;
  return n + 1;
}

void set_err_message(char *msg) {
  gtk_widget_set(errmsg, "label", msg, NULL);
}
